package net.nicoptere.cellular {
	import flash.display.Sprite;

	import net.nicoptere.delaunay.*;
	import net.nicoptere.utils.*;
import flash.geom.*;
	/**
	 * @author nicoptere
	 */
	public class Core extends Sprite 
	{
		public var nodes:Array;
		public var hull:Array;
		
		public function Core( size:Number, nodeCount:int) 
		{
		
			init( size , nodeCount );
			
		}
		public function init( size:Number, nodeCount:int ):void
		{
			nodes = [];
			hull = [];
			var i:int;
			var x:Number;
			var y:Number;
			var a:Number;
			var pt:DelaunayPoint;
			for ( i = 0; i < nodeCount; i++ )
			{
				
				a = ( i * ( 360 / nodeCount ) ) / 180 * Math.PI;
				x =  Math.cos( a ) * Math.random()*size;
				y =  Math.sin( a ) * Math.random()*size;
				pt = new DelaunayPoint( x,y );	
				nodes.push( pt );
				hull.push( new Point(x,y) );
				
			}
			process();
			
		}
			
		public function process():void
		{	
			nodes = Delaunay.Triangulate( nodes );
			hull = Hull.convexHull( hull );
		}
		
		
		public function render():void
		{
			
			graphics.clear();
			graphics.lineStyle( 1, 0xFFCC00 );
			Voronoi.draw(nodes, graphics);
			Hull.drawHull(hull, graphics);
			
		}
		
		public function dispose():void
		{
			graphics.clear();
			var p:Point;
			for each( p in hull )p = null;
			hull = [];
			
			var t:Triangle;
			for each( t in nodes )t = null;
			nodes = [];
			
		}
	}
}
