package net.nicoptere.cellular {
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.filters.*;

	/**
	 * @author nicoptere
	 */
	public class Creature extends Sprite 
	{
		public var body:Body; 
		public var eye:Eye; 
		public var nucleus:Core;
		public var limbs:Array;
		 
		 public var size:Number;
		 public var nuclei:int;
		 
		public function Creature( x:Number=250, y:Number=250, size:Number = 50, nuclei:int = 50  ) 
		{
			
			this.x = x;
			this.y = y;
			
			this.size = size;
			this.nuclei = nuclei;
			limbs = [];
			
			init();
			
		}
		
		public function init():void
		{	
			
			nucleus = new Core( size, nuclei);
			addChild( nucleus );
			
			body = new Body( nucleus.hull.concat(), 2 );
			addChild( body );
			
			
			var l:Limb;
			//prend une destination au hasard (les fibres pointent dans l'autre sens)
			var target:Point = new Point( ( Math.random()-.5  )* 100, ( Math.random() - .5) * 100 );
			for each( var c:Point in nucleus.hull )
			{
				
				l = new Limb( c, target, Math.random()*size/2, size );
				addChild( l );
				limbs.push( l );
				
			}
			
		}
		
		public function render():void
		{
			
			nucleus.render();
			
			for each( var l:Limb in limbs )
			{
				l.render(  );	
			}
			
			body.render();
			var blurx:Number = size * scaleX;
			var blury:Number = size * scaleY;
			body.filters = [ new GlowFilter( 0xFFCC00, 1, blurx, blury, 1, 1, true, true )  ];
		
		}
		
		public function dispose():void
		{
			size = 0;
			nuclei = 0;
				
			nucleus.dispose();
			removeChild( nucleus );
				
			
			body.dispose();
			removeChild( body );
			
			var l:Limb;
			
			for each( l in limbs )
			{
				l.dispose();
				removeChild( l );
			}
			limbs = [];
			
		}
		
	}
}
