package net.nicoptere.cellular 
{
	import flash.display.Sprite;
	import flash.geom.*;


	/**
	 * @author nicoptere
	 */
	public class Limb extends Sprite 
	{
		public var origin:Point;
		public var nodes:Array;
		
		public function Limb( origin:Point, target:Point, segments:Number = 5, length:Number =10 ) 
		{
			
			this.origin = origin;
			
			nodes = [ origin ];
			
			var dx:Number = target.x - origin.x;
			var dy:Number = target.y - origin.y;
			var a:Number = Math.atan2( dy, dx )- Math.PI;
			
			var cp:Point = origin;
			
			dx = origin.x + Math.cos( a ) * length;///segments; 
			dy = origin.y + Math.sin( a ) * length;//segments; 
			cp = new Point( dx, dy );
			
			nodes.push( cp );
			
			for( var i:int = 1; i < segments; i++ )
			{
				
				
				a += ( Math.random() - .5 ) ;
				dx += Math.cos( a ) * length*i/segments; 
				dy += Math.sin( a ) * length*i/segments; 
				
				cp = new Point( dx, dy );
				nodes.push( cp );
				
				
			}	
			
			
		}
		public function render():void
		{
			
			graphics.clear();
			graphics.lineStyle( 10, 0xFFCC00, .5 );
			graphics.drawCircle( origin.x, origin.y, (nodes.length - i )/10 );
			
			var pt:Point = nodes[ 0 ];
			graphics.lineTo( origin.x,origin.y );

			for( var i:int = 0; i < nodes.length-1; i++ )
			{
				
				graphics.lineStyle( 6-i, 0xFFCC00, .5 );
				pt = nodes[ i ];
				
				graphics.lineTo( pt.x, pt.y );
				graphics.drawCircle( pt.x, pt.y, (nodes.length - i )/10 );
				graphics.moveTo( pt.x, pt.y );
				
			}	
			
		}
		
		
		public function dispose():void
		{
			
			graphics.clear();
			var p:Point;
			for each( p in nodes )p = null;
			nodes = [];
			
		}
	}
}
