package net.nicoptere.utils {

	import flash.display.Graphics;
	import flash.geom.Point;
	/**
	 * @author Keith Peters
	 * http://www.bit-101.com/blog/?p=1497
	 */
	public class Hull 
	{
	
		static public function convexHull(points:Array):Array
		{

		    points.sortOn("x", Array.DESCENDING|Array.NUMERIC);
		    var point:Point = points[0] as flash.geom.Point;
		    var hull:Array = new Array();
		    var angle:Number = Math.PI / 2;
		    while (point != hull[0])
		    {
		        hull.push(point);
		        var bestAngle:Number = Number.MAX_VALUE;
		        var bestIndex:int;
		        for (var i:int = 0; i <points.length; i++)
		        {
		            var testPoint:Point = points[i] as Point;
		            if (testPoint == point)
		            {
		                continue;
		            }
		            var dx:Number = testPoint.x - point.x;
		            var dy:Number = testPoint.y - point.y;
		            var testAngle:Number = Math.atan2(dy,dx);
		            testAngle -= angle;
		            while (testAngle <0)
		            {
		                testAngle+=Math.PI*2;
		            }
		            if (testAngle<bestAngle)
		            {
		                bestAngle=testAngle;
		                bestIndex=i;
		            }
		        }
		        point=points[bestIndex];
		        angle+=bestAngle;
		    }
		    return hull;
		}
		static public function drawHull(hull:Array, graphics:Graphics):void
		{
		    graphics.moveTo(hull[0].x, hull[0].y);
		    for(var i:int = 1; i <hull.length; i++)
		    {
		        graphics.lineTo(hull[i].x, hull[i].y);
		    }
		    graphics.lineTo(hull[0].x, hull[0].y);
		}
	}
}
